#include <map>
#include <iostream>
#include <cstdint>

int main(){
    std::ios_base::sync_with_stdio(false);

    int L, S, M, D, B;
    while (std::cin >> L >> S >> M >> D >> B && L != 0){
        std::map<int, int64_t> polivky;
        for (int s = 0; s < S; ++S){
            int cost;
            std::cin >> cost;
            polivky[cost]++;
        }
        int64_t current_total = 0;
        for (auto& p : polivky){
            current_total += p.second;
            p.second = current_total;
        }

        std::map<int, int64_t> jidla;
        for (int m = 0; m < M; ++m){
            int cost;
            std::cin >> cost;
            jidla[cost]++;
        }

        current_total = 0;
        std::map<int, int64_t> prefix_jidla;
        for (auto& j : jidla){
            for (auto& p : polivky){
                prefix_jidla[j.first + p.first] = p.second * j.second;
            }
        }

        // Dezerty
        std::map<int, int64_t> dezerty;
        for (int d = 0; d < D; ++d){
            int cost;
            std::cin >> cost;
            dezerty[cost]++;
        }
        current_total = 0;
        for (auto& d : dezerty){
            current_total += d.second;
            d.second = current_total;
        }

        // Napoje
        std::map<int, int64_t> napoje;
        for (int b = 0; b < B; ++b){
            int cost;
            std::cin >> cost;
            napoje[cost]++;
        }

        std::map<int, int64_t> prefix_napoje;
        for (auto& n : napoje){
            for (auto& d : dezerty){
                prefix_napoje[n.first + d.first] = n.second * d.second;
            }
        }

        uint64_t best = 0;
        for (auto& pn : prefix_napoje){
            auto cash_left = L - pn.first;
            auto possible = prefix_jidla.upper_bound(cash_left)->second;
            if (possible * pn.second > best){
                best = possible * pn.second;
            }
        }

        std::cout << best << std::endl;
    }

}
